import Foundation
import UIKit

class CreateAccViewController : UIViewController {}



//: #### SwiftGenStoryboardEnumBuilder Usage Example

let enumBuilder = SwiftGenStoryboardEnumBuilder()
if let sbFile1 = NSBundle.mainBundle().pathForResource("Wizzard", ofType: "storyboard") {
    enumBuilder.addStoryboardAtPath(sbFile1)
}
if let sbFile2 = NSBundle.mainBundle().pathForResource("Message", ofType: "storyboard") {
    enumBuilder.addStoryboardAtPath(sbFile2)
}
print(enumBuilder.build())



//: #### Code Generated by the Builder

protocol StoryboardScene : RawRepresentable {
    static var storyboardName : String { get }
    static func storyboard() -> UIStoryboard
    static func initialViewController() -> UIViewController
    func viewController() -> UIViewController
    static func viewController(identifier: Self) -> UIViewController
}

extension StoryboardScene where Self.RawValue == String {
    static func storyboard() -> UIStoryboard {
        return UIStoryboard(name: self.storyboardName, bundle: nil)
    }
    static func initialViewController() -> UIViewController {
        return storyboard().instantiateInitialViewController()!
    }
    
    func viewController() -> UIViewController {
        return Self.storyboard().instantiateViewControllerWithIdentifier(self.rawValue)
    }
    static func viewController(identifier: Self) -> UIViewController {
        return identifier.viewController()
    }
}


enum Wizzard : String, StoryboardScene {
    static let storyboardName = "Wizzard"
    
    case CreateAccount = "CreateAccount"
    case AcceptCGU = "Accept-CGU"
    case ValidatePassword = "Validate_Password"
    case Preferences = "Preferences"
    
    static var createAccountViewController : CreateAccViewController { return Wizzard.CreateAccount.viewController() as! CreateAccViewController }
    static var acceptCGUViewController : UIViewController { return Wizzard.AcceptCGU.viewController() }
    static var validatePasswordViewController : UIViewController { return Wizzard.ValidatePassword.viewController() }
    static var preferencesViewController : UIViewController { return Wizzard.Preferences.viewController() }
}



//: #### Usage Example

let initialVC = Wizzard.initialViewController()
let validateVC = Wizzard.ValidatePassword.viewController()
/* Note: the following line would crash when run in playground, because the storyboard file
   was not compiled alongside the playground code, so the CreateAccViewController class was
   not known by the storyboard. But it should work correctly in a real project. */
// let cgu = Wizzard.createAccountViewController

initialVC.title
validateVC.title
